--    ======================
--    Description
--    ======================
--
--    Jeżeli którakolwiek data z listy (dzień i miesiąc, bez roku) jest równa wskazanej dacie (np. aktualna data) to na wyjściu pojawia się zdefiniowana wartość aktywna (np. 1).
--    W innym wypadku na wyjściu pojawia się wartość nieaktywna (np. 0)
--
--    ======================
--    Parameters
--    ======================
--
--    SubLogic supports following variables:
--
--    input.dt.month                          - wejście - miesiąc [0..11]. 0 - styczeń, 11- grudzień
--
--    input.dt.mday                           - wejście - dzień miesiąca [1..31].
--
--    output                                  - stan wyjścia
--
--    counter.dt.no                           - ilość dni w liście "dates"
--
--    setting.value.active                    - wartość która pojawi się na wyjściu, jeżeli chociaż jedna data z listy jest równa dacie z wejścia
--
--    setting.value.inactive                  - wartość która pojawi się na wyjściu, jeżeli każda data z listy jest równa dacie z wejścia
--
--    setting.dt.month                        - lista "dates" - miesiąc [0..11]. 0 - styczeń, 11- grudzień
--
--    setting.dt.mday                         - lista "dates" - dzień miesiąca [1..31].
--
--    setting.dt.enabled                      - lista "dates" - rok [0..1]. Flaga. Czy dany dzień ma być barny pod uwagę w procesie porównywania
--
--    Logic uses lua language to implement own behaviour
--
--    ======================
--    mandatory variables
--    ======================
--
--    Logic expects following mandatory variables:
--
--    reload.trigger                          - causes reloading lua script
--
--    memcnt                                  - current amount of memory used by lua in bytes
--
--    Logic expects following kv settings:
--
--    LuaScriptPath                           - path to the lua script - must be absolute
--
--    ======================
--    ChangeLog
--    ======================
--
--    2023-01-01 ver 1.0.0
--
--    # First release
--
-- user can use some functions provided by ibmanager.

-- ibmanager provides following functions to use:
--
-- function returns value of required ibmanager variable
-- @param fullName - string - variable name - name of variable of which value must be returned, for example "rs.0.id.255.input.t.0.value"
-- @return         - string or integer - variable value or "nil" if variable not exist or is not readable
--
-- getValue(fullName)


-- function set value of given ibmanager variable
-- @param fullName - string - variable name - name of variable of which value we want to set, for example "rs.0.id.255.input.t.0.value"
-- @param value    - string, int or boolean - value to set
-- @return         - nothing
--
-- setValue(fullName, value)


-- function returns value of required ibmanager variable
-- @param key      - placed in xml logic configuration file:
--                   * as attribute: Name, in Var, RemoteVar and ImportVar elements in the case of stand alone variables
--                   * as concatenation of two attributes: ListName.Postfix in VarListItem, RemoteVarListItem and ImportVarListItem elements
--                     in the case of variables that are placed in lists
-- @return         - string or integer - variable value or "nil" if variable not exist or is not readable
--
-- getLogicValue(key)


-- function set value of given ibmanager variable
-- @param key      - placed in xml logic configuration file:
--                   * as attribute: Name, in Var, RemoteVar and ImportVar elements in the case of stand alone variables
--                   * as concatenation of two attributes: ListName.Postfix in VarListItem, RemoteVarListItem and ImportVarListItem elements
--                     in the case of variables that are placed in lists
-- @param value    - string, int or boolean - value to set
-- @return         - nothing
--
-- setLogicValue(key, value)

-- function returns two sections of kvsettings from xml configuration file
-- returned value is two element table, each of these elements is table too.
-- indices of returned table are strings and equal "instance" and "global"
-- values of returned tables are tables and contain KVsettings for applicable section.
-- nested tables have form key = value, where key is index in nested table and value is value.
-- example: {"instance" = {"ikey1" = "ivalue1", "ikey2" = "gvalue2"}, "global" = {"gkey1" = "gvalue1", "gkey2" = "gvalue2", "gkey3" = "gvalue3"}}
-- @return          - two dimensional array - kvsettings for global and instance sections
-- getKvSettings()


-- function schedules alert to send.
-- rules are defined in separated alert configuration files and are described in ibmanager instruction manual
-- @param id - alert identifier - must be defined in current logic configuration file in section: <Alert Id="any_identifier" ...
-- scheduleAlert(id)

-- function cancels alert sending, if was previously scheduled. if not then only wakes up alerts handling thread, so if there is no need to call this function, then do not call it.
-- rules are defined in separated alert configuration files and are described in ibmanager instruction manual
-- @param id - alert identifier - must be defined in current logic configuration file in section: <Alert Id="any_identifier" ...
-- cancelAlert(name)

-- function returns table, containing Variables that belongs to required list.
-- @param listName - Name attribute of VarList, RemoteVarList or ImportVarList elemetnst in configurationfile
-- @return array of key-value pairs. Key - variable postfix, Value - Variable value
-- getVarList(listName)

-- function returns monotonic system clock value, that elapsed since specific epoch
-- returned time is expressed in milliseconds.
-- getClock()

-- function logs message to file, if defined in configuration file log level is less than passed to this function
-- @param logLevel - one of:
--        LogLevel.TraceLo
--        LogLevel.Trace
--        LogLevel.TraceHi
--        LogLevel.DebugLo
--        LogLevel.Debug
--        LogLevel.DebugHi
--        LogLevel.Info
--        LogLevel.Notice
--        LogLevel.Warning
--        LogLevel.Error
--        LogLevel.Critical
-- @param logMessage - string to log
-- log(logLevel, logMessage)


-- ibmanager provides following global variables:

-- logic type, (in this case it will always be "Lua") - the same as in logic configuration file in section: <Logic Type="Lua" ...
-- LOGIC_TYPE

-- logic version, the same as in logic configuration file in section: <Logic ... Version="x.y.z" ...
-- LOGIC_VERSION

-- logic sub-type, the same as in logic configuration file in section: <Logic ... SubType="Hysteresis" ...
-- LOGIC_SUBTYPE

-- logic sub-version, the same as in logic configuration file in section: <Logic ... SubVersion="x.y.z" ...
-- LOGIC_SUBVERSION

-- logic instance name - the same as in logic configuration file, in section: <Instance Name="0">
-- LOGIC_INSTANCE_NAME

-- add script directory to package path
package.path = package.path .. ";./logic/scripts/utils/?.lua";

-- use script - without .lua extension - delta class
require("DownCounter");

SUPPORTED_SUBLOGIC_TYPE = "IsDate";
SUPPORTED_SUBLOGIC_VERSION = "1.0.0";
g_versionChecked = false;

g_datesCount = 0;
g_checkList = 0;

g_tableDatesPostfix = {};

g_settingDtMonth = {};
g_settingDtMday = {};
g_settingDtEnabled = {};

-- zwraca 1 jeżeli listy są OK
function checkLists()
  local fail = false

  if (g_datesCount == 0) then
    log(LogLevel.Error, "VarList setting.id not initialized in instance section of configuration.")
    fail = true
  else
    for i = 0, g_datesCount-1, 1 do

      -- Check for fail

      if g_settingDtMonth[g_tableDatesPostfix[i]] then
      else
        log(LogLevel.Error, "VarList element setting.dt.month." .. g_tableDatesPostfix[i] .. " not initialized in instance section of configuration.")
        fail = true
      end

      if g_settingDtMday[g_tableDatesPostfix[i]] then
      else
        log(LogLevel.Error, "VarList element setting.dt.mday." .. g_tableDatesPostfix[i] .. " not initialized in instance section of configuration.")
        fail = true
      end

      if g_settingDtEnabled[g_tableDatesPostfix[i]] then
      else
        log(LogLevel.Error, "VarList element setting.dt.enabled." .. g_tableDatesPostfix[i] .. " not initialized in instance section of configuration.")
        fail = true
      end

    end
  end

  if fail then
    return 0
  else
    return 1
  end

end

function readAll(file)
    local f = assert(io.open(file, "rb"))
    local content = f:read("*all")
    f:close()
    return content
end

-- entry point to the logic
function onLogicCall(firstCall)

  if not g_versionChecked then
    -- checking sublogic type and sublogic version
    if LOGIC_SUBTYPE ~= SUPPORTED_SUBLOGIC_TYPE then
      error("Wrong logic sub-type. expected " .. SUPPORTED_SUBLOGIC_TYPE .. " but used " .. LOGIC_SUBTYPE);
    end
    local versionWithoutBuild = string.match(LOGIC_SUBVERSION, "[0-9]+%.[0-9]+%.[0-9]+");
    if versionWithoutBuild ~= SUPPORTED_SUBLOGIC_VERSION then
      error("Wrong logic sub-version. expected " .. SUPPORTED_SUBLOGIC_VERSION .. " but used " .. LOGIC_SUBVERSION);
    end
    g_versionChecked = true;
  end

  local inputDtMonth                     = getLogicValue("input.dt.month");
  local inputDtMday                      = getLogicValue("input.dt.mday");
  local settingValueActive               = getLogicValue("setting.value.active");
  local settingValueInactive             = getLogicValue("setting.value.inactive");

  local settingDtMonth                   = getVarList("setting.dt.month");
  local settingDtMday                    = getVarList("setting.dt.mday");
  local settingDtEnabled                 = getVarList("setting.dt.enabled");

  local output

  local i = 0;
  g_datesCount = 0;

  -- tablica
  if settingDtMonth ~= nil then
    for postfix, value in pairs(settingDtMonth) do
      g_settingDtMonth['' .. postfix] = value;

      g_tableDatesPostfix[g_datesCount] = postfix
      g_datesCount = g_datesCount + 1;

    end
  end

  -- tablica
  if settingDtMday ~= nil then
    for postfix, value in pairs(settingDtMday) do
      g_settingDtMday['' .. postfix] = value;
    end
  end

  -- tablica
  if settingDtEnabled ~= nil then
    for postfix, value in pairs(settingDtEnabled) do
      g_settingDtEnabled['' .. postfix] = value;
    end
  end

  if (firstCall) then
    g_checkList = checkLists()
  end

  output = settingValueInactive

  if g_checkList == 1 then

    local tmp_settingDtMonth;
    local tmp_settingDtMday;
    local tmp_settingDtEnabled

    for i = 0, g_datesCount-1, 1 do

      tmp_settingDtMonth = g_settingDtMonth[g_tableDatesPostfix[i]];
      tmp_settingDtMday = g_settingDtMday[g_tableDatesPostfix[i]];
      tmp_settingDtEnabled = g_settingDtEnabled[g_tableDatesPostfix[i]];

      --print('=================');
      --print('i: ' .. i);
      --print('g_tableDatesPostfix[i]: ' .. g_tableDatesPostfix[i]);
      --print('settingDtMonth: ' .. tmp_settingDtMonth);
      --print('settingDtMday: ' .. tmp_settingDtMday);
      --print('settingDtEnabled: ' .. tmp_settingDtEnabled);

      if ((tmp_settingDtEnabled == 1) and (tmp_settingDtMonth == inputDtMonth) and (tmp_settingDtMday == inputDtMday)) then
        --print('Break! ');
        output = settingValueActive
        break
      end

      --setLogicValue("counter.tslc." .. g_tableDatesPostfix[i], tmp_tlc);
      --setLogicValue("counter.err.downcounter." .. g_tableDatesPostfix[i], counterErrDowncounter[g_tableDatesPostfix[i]]);
      --setLogicValue("counter.err.state." .. g_tableDatesPostfix[i], counterErrState[g_tableDatesPostfix[i]]);

    end

    setLogicValue("output", output);
    setLogicValue("counter.dt.no", g_datesCount);
  else
    setLogicValue("output", output);
    setLogicValue("counter.dt.no", 0);
  end

end
